'use strict';

exports.__esModule = true;

var loadComponents = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
    var ids;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(typeof window === 'undefined')) {
              _context.next = 2;
              break;
            }

            throw new Error('`loadComponents` must be called client-side: `window` is undefined');

          case 2:
            ids = window[_constants.COMPONENT_IDS] || [];
            return _context.abrupt('return', Promise.all(ids.map(function (id) {
              return componentTracker.get(id)[_constants.LOADABLE]().load();
            })));

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function loadComponents() {
    return _ref.apply(this, arguments);
  };
}();

var _constants = require('./constants');

var _componentTracker = require('./componentTracker');

var componentTracker = _interopRequireWildcard(_componentTracker);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* eslint-env browser */


exports.default = loadComponents;